--[[ gpGfB^ SciTE  TAB=2 ]]

--[[ Public Const for Tracer ]]
PACK_NUM		= 1
DEBUG_LOOP		= -1
DEBUG_LEVEL	= 20
TRACE_PARAM	= 20
TRACE_TABLE	= 100
DEBUG_MODE	= false
TRACE_ON			= true
LOAD_TEST		= false

--[[ Private Parameter ]]
local DebugLoopCount	= 0
local AI_StartTime			= 0
local AI_StartTick			= 0
local AI_PrevStartTime	= 0
local AI_PrevStartTick		= 0
local AI_TickSub				= 0
local StressCount			= 0


-----------------


--[[ Public ]]
function AI(myid)
	OS_TIME	= os.time()
	TICK_TIME	= GetTick()
	
	if IMPORT_COMPLETE then
		Trace("AI","Start")
		CliantStressCheck()
		
		if DEBUG_MODE then
			if DEBUG_LOOP < 0 then
				Main(myid)
			else
				DebugLoopCount = DebugLoopCount+1
				if DebugLoopCount <= DEBUG_LOOP then
					Main(myid)
				end
			end
		else
			Main(myid)
		end
		
		Trace("AI","End")
		TraceAI("           ProcessCost : " .. GetAiCount() .. "  ( " .. (GetTick() - TICK_TIME) .. " )")
		TraceAI("")
		
	else
		ImportLua(myid)
		
		--ImportOȂ̂Œ
		local OwnerID	= GetV(V_OWNER, myid)
		local OwPosX, OwPosY	= GetV(V_POSITION, OwnerID)
		Move(myid, OwPosX, OwPosY)
	end
end

--[[ Private ]]
function Main(myid)
	if My.AIEnable then
		Trace("AI Main","Start")
			
		CliantStressControl()
		ifDecision(myid)
			
		Trace("AI Main","End")
	end
end


------------------


--[[ Public ]]
function CliantStressCheck()
	Trace("CliantStressCheck")
	AI_StartTime	= OS_TIME
	AI_StartTick	= TICK_TIME
	
	if not (AI_StartTime==AI_PrevStartTime) then	--Pbi񂾂Ƃ
		AI_PrevStartTime = AI_StartTime
		
		AI_TickSub	= AI_StartTick - AI_PrevStartTick
		AI_PrevStartTick = AI_StartTick
	end
end

--[[ Public ]]
function CliantStressControl()
	Trace("CliantStressControl")
	
	local Stress = AI_TickSub - 1000
	if Stress<0 then Stress = Stress * -1 end
	
	if (AI_TickSub==AI_PrevStartTick) or (STRESS_TIME<Stress) then
		StressCount = StressCount+1
		
		if STRESS_BORDER <= StressCount then
			CYCLE_DELAY = CYCLE_DELAY * RELIEF_VALUE
		end
	else
		if 0 <= StressCount then 
			StressCount = StressCount-1
			
			if STRESS_BORDER <= StressCount+1 then
				CYCLE_DELAY = CYCLE_DELAY / RELIEF_VALUE
				if CYCLE_DELAY < 1 then
					CYCLE_DELAY = 1
				end
			end
		end
	end
	--[[
	TraceAI("           " .. TICK_TIME .. "  Sub : " .. AI_TickSub)
	TraceAI("           Stress      : " .. Stress)
	TraceAI("           StressCount : " .. StressCount)
	TraceAI("           CycleDelay  : " .. CYCLE_DELAY)
	TraceAI("           Delay       : " .. TICK_TIME - (PREV_SCAN_TIME+SCANNING_SPAN+CYCLE_DELAY)) --vXlȂusvƂȂ
	--]]
end

--[[ Public ]] --_ł̃JEgԂ
function GetAiCount()
	return (GetTick() - AI_StartTick) / 16
end


---------------------


PACKAGE_EXT = ".lua"
if (PACK_NUM==1) then
	LOAD_TEST		= false
	PACKAGE_DIR	= "./AI/USER_AI"
	dofile( PACKAGE_DIR .."/PublicConst.lua")
	dofile( PACKAGE_DIR.."/PackageLoader.lua")
else
	if (PACK_NUM==2) then
		PACKAGE_DIR="H:/RO_HomAI/AI/USER_AI"
	elseif (PACK_NUM==3) then
		PACKAGE_DIR="F:/AI/AI/USER_AI"
	end
	
	LOAD_TEST		= true
	dofile( PACKAGE_DIR .."/TestParameter.lua")
	dofile( PACKAGE_DIR .."/PublicConst.lua")
	dofile( PACKAGE_DIR .."/PackageLoader.lua")
	
	for i=1,  50 do
		AI(12829)
	end
end

