Evaluation = {}
local Player = {}
local Homun = {}


--[[ Public ]]
function Evaluation.EnemyEvaluation(ActorData, TargetData)
	local ActParam	= Evaluation.GetActorParameter(ActorData)
	local TgtParam	= Evaluation.GetActorParameter(TargetData)
	
	--if 2 <= List.Size(TargetData.Enemy)  then result = 1 end
	local Evasion			= Evaluation.Evasion(ActParam, TgtParam)
	local HitDamage		= Evaluation.HitDamage(ActParam, TgtParam)
	local Acuracy			= Evaluation.Acuracy(ActParam, TgtParam)
	local AttackDamage = Evaluation.AttackDamage(ActParam, TgtParam)
	local SkillDamage	= Evaluation.SkillDamage(ActParam, TgtParam)
	--local Size			= List.Size(TgtParam.Enemy)
	
	local Distance		= Evaluation.Distance(ActorData, TargetData)
	
	local EvMobility		= Evasion + Distance
	local EvDeffence	= EvMobility + HitDamage
	
	local EvAttack		= EvDeffence + AttackDamage + Acuracy
	local EvSkill			= EvDeffence + SkillDamage
	
	local ActorName
	if IsTrue(ActorData.Status.Name) then
		ActorName = ActorData.Status.Name
	else
		ActorName = ActorData.ID
	end
	
	local TargetName
	if IsTrue(TargetData.Status.Name) then
		TargetName = TargetData.Status.Name
	else
		TargetName = TargetData.ID
	end
	
	Trace("EnemyEvaluation " .. EvAttack .." :   ".. ActorName .. "  " .. TargetName, "", TRACE_PARAM)
	return EvAttack, EvSkill
end

function Evaluation.FriendEvaluation(ActorID)
	return My.ID --bI
end

function Evaluation.GetDangerLevel(ActorID)
end


----------------------


--[[ Public ]]
function Evaluation.GetBaseAttack(AttackActor)
	local Passive	= 10
	return AttackActor.Str + (AttackActor.Str/10)*2 + (AttackActor.Dex/5) + (AttackActor.Luk/5) + Passive
end

--[[ Public ]]
function Evaluation.Distance(ActorData, TargetData)
	local Distance = Position.GetDistance(ActorData.ID, TargetData.ID)
	
	if Distance <= 2 then
		return 2
	elseif Distance <= 4 then
		return 1
		
	elseif Distance <= 6 then
		return 0
		
	elseif Distance <= 10 then
		return -1
	elseif Distance <= 15 then
		return -2
	else
		return -3
		
	end
end

--[[ Public ]] --m]
function Evaluation.Evasion(ActParam, TgtParam)
	local Evasion = Evaluation.GetEvasion(ActParam, TgtParam)
	
	if 90 < Evasion then
		return 2
	elseif 70 < Evasion then
		return 1
		
	elseif 50 < Evasion then
		return 0
		
	elseif 35 < Evasion then
		return -1
	else
		return -2
		
	end
end

--[[ Public ]] --e_[Wŕ]
function Evaluation.HitDamage(ActParam, TgtParam)
	local Damage	= Evaluation.GetAttackDamage(TgtParam, ActParam)
	local Rate		= Damage / My.GetHP() * 100
	
	if Rate < 10 then
		return 2
	elseif Rate < 25 then
		return 1
		
	elseif Rate < 35 then
		return 0
		
	elseif Rate < 45 then
		return -1
	elseif Rate < 60 then
		return -2
	elseif Rate < 80 then
		return -3
	else
		return -4
		
	end
end

--[[ Public ]] --m]
function Evaluation.Acuracy(ActParam, TgtParam)
	local Acuracy = Evaluation.GetAcuracy(ActParam, TgtParam)
	
	if 90 < Acuracy then
		return 2
	elseif 70 < Acuracy then
		return 1
		
	elseif 55 < Acuracy then
		return 0
		
	elseif 40 < Acuracy then
		return -1
	else
		return -2
		
	end
end

--[[ Public ]] --ė^_[W]
function Evaluation.AttackDamage(ActParam, TgtParam)
	local Damage	= Evaluation.GetAttackDamage(ActParam, TgtParam)
	return Evaluation.Damage(Damage, TgtParam.HP)
end

--[[ Public ]] --XLŗ^_[W]
function Evaluation.SkillDamage(ActParam, TgtParam)
	local Damage	= Evaluation.GetSkillDamage(ActParam, TgtParam)
	return Evaluation.Damage(Damage, TgtParam.HP)
end

--[[ Private ]] --_[Wŕ]
function Evaluation.Damage(Damage, HP)
	local Rate		= Damage / HP * 100
		
	if 60 < Rate then
		return 3
	elseif 40 < Rate then
		return 2
	elseif 20 < Rate then
		return 1
		
	elseif 10 < Rate then
		return 0
		
	elseif 5 < Rate  then
		return -1
	elseif 3 < Rate then
		return -2
	else
		return -3
		
	end
end

--[[ Private ]]
function Evaluation.GetActorParameter(ActorData)
	local Param = ActorData.Status
	
	if Param.Atk==0 or Param.Atk==nil then
		Param.Atk = Evaluation.GetBaseAttack(Param)
	end
	
	if Param.Matk==0 or Param.Matk==nil  then
		Param.Matk=0
	end
	
	if Param.Hit==0 or Param.Hit==nil  then
		Param.Hit=0
	end
	
	if Param.Critical==0 or Param.Critical==nil  then
		Param.Critical=0
	end
	
	if Param.Def==0 or Param.Def==nil  then
		Param.Def=0
	end
	
	if Param.Mdef==0 or Param.Mdef==nil  then
		Param.Mdef=0
	end
	
	if Param.Flee==0 or Param.Flee==nil  then
		Param.Flee=0
	end
	
	return Param
end


-----------------


--[[ Public ]] --AttackActor  EvadeActor UAEvadeActorm
function Evaluation.GetEvasion(EvadeActor, AttackActor)
	return 80
end

--[[ Public ]] --AttackActor  TargetActor UAm
function Evaluation.GetAcuracy(AttackActor, TargetActor)
	return 70
end

--[[	{U		= STR + STR{[iX + DEX/5 + LUK/5 + ATK㏸J[h 
		U(ő)	= {U + (ATK-1) x TCYC 
		U(ŏ)	= {U + DEX x Lv␳ x TCYC 
		^_[W		= [ {U x XL x (100-GDEF)/100 + B - GVIT} + C]  x G x %UPnJ[h 	]]
		
--[[ Public ]] --AttackActor  TargetActor UA^_[W
function Evaluation.GetAttackDamage(AttackActor, TargetActor)
	local Skill		= 1
	local Refine	= 0
	local Passive	= 10
	local Card		= 1
	
	local MaxAtk	= AttackActor.AtkMax
	local MinAtk	= AttackActor.AtkMin
	
	local Element = Evaluation.GetElementParam(AttackActor, TargetActor)
	
	local res =  ( (MaxAtk * Skill * (100-TargetActor.Def)/100 + Refine - TargetActor.Vit) + Passive ) * Element * Card
	
	return res
end

function Evaluation.GetSkillDamage(AttackActor, TargetActor)
	return 3
end

--[[ Public ]]
function Evaluation.GetElementParam(AttackActor, TargetActor)
	return 1
end


--------------------
--Homun
--------------------
--[[
	STR	:	ATK = Lv + 2 * STR + Floor(STR/10)^2
	AGI	:	Flee = Lv + AGI
	VIT	:	DEF = VIT + Floor(VIT/5) + Floor(Lv/10)
	INT	:	MATK = INT + Floor(INT/5)^2
				MDEF = Floor(INT/5) + Floor(Lv/10)
	DEX	:	HIT = Lv + DEX
	LUK	:	Cri = Floor(Luk/3) + 1 
]]


--------------------
--Player
--------------------
