Finding	= {}


--[[ Public Parameter ]]
local ActorDataList		= List.New()
local EnemyIDList		= List.New()
local FriendIDList		= List.New()
local UnknownIDList	= List.New()


-------------------------


--[[ Public ]]
function Finding.RenewActorData()
	Trace("RenewActorData")
	
	ActorDataList 	= nil
	ActorDataList 	= List.New()
	
	EnemyIDList		= nil
	EnemyIDList		= List.New()
	
	FriendIDList		= nil
	FriendIDList		= List.New()
	
	UnknownIDList	= nil
	UnknownIDList	= List.New()
end

--[[ Public ]]
function Finding.GetActorData(ActorID)
	if DEBUG_MODE then
		local res = ActorDataList[ActorID]
		if IsNil(res) then
			Trace("GetActorData : NoData " .. ActorID, "", TRACE_PARAM)
		else
			Trace("GetActorData : " .. ActorID, "", TRACE_PARAM)
		end
		return res
	else
		return ActorDataList[ActorID]
	end
end

--[[ Public ]]
function Finding.SetActorData(ActorData)
	if DEBUG_MODE then
		local dat = ActorDataList[ActorData.ID]
		if IsNil(dat) then
			Trace("SetActorData : " .. ActorData.ID, "", TRACE_PARAM)
		else
			Trace("SetActorData : Update ".. ActorData.ID, "", TRACE_PARAM)
		end
	end
	ActorDataList[ActorData.ID] = ActorData
end

--[[ Public ]]
function Finding.GetActorIDList(ActorType)
	Trace("GetActorIDList : " .. ActorType, "", TRACE_PARAM)
	
	if ActorType == ACT_FRIEND then
		return FriendIDList
		
	elseif ActorType == ACT_ENEMY then
		return EnemyIDList
		
	elseif ActorType == ACT_UNKNOWN then
		return UnknownIDList
		
	end
end

--[[ Public ]]
function Finding.SetActorIDList(ActorType, IDList)
	Trace("SetActorIDList : " .. ActorType, "", TRACE_PARAM)	

	if ActorType == ACT_FRIEND then
		FriendIDList		= nil
		FriendIDList		= IDList
		
	elseif ActorType == ACT_ENEMY then
		EnemyIDList		= nil
		EnemyIDList		= IDList
		
	elseif ActorType == ACT_UNKNOWN then
		UnknownIDList	= nil
		UnknownIDList	= IDList
		
	end
end

--[[ Public ]]
function Finding.IsEncount()
	local OwnerData	= Finding.GetActorData(My.Owner.ID)
	local MyData		= Finding.GetActorData(My.ID)
	
	if 0<OwnerData.EnemyList.count or 0<My.Data.EnemyList.count then
		return true
	else
		return false
	end
end
