local DecisionAI = {}


--[[ Private Parameter ]]
local AiFirstRun = true


--------------------


--[[ Public ]]
function ifAIActivate(Flag)
	DecisionAI.AIActivate(Flag)
end

--[[ Public ]]
function ifDecision(myid)
	Trace("DecisionAI","Start")
	
	if AiFirstRun==true then
		DecisionAI.Initialize(myid)
		AiFirstRun = false
	end
	DecisionAI.Main()
	
	Trace("DecisionAI", "End")
end


--------------------


--[[ Private ]]
function DecisionAI.AIActivate(Flag)
	if Flag then
		Trace("AI Activate")
		My.AIEnable = true
	else
		Trace("AI DeActivate")
		My.AIEnable = false
	end
end

--[[ Private ]]
function DecisionAI.Initialize(myid)
	Trace("Init","Start")
		My.Initialize(myid)
		
		if GetV(V_MOTION, My.Owner.ID) then
			DecisionAI.OnCallHomun()
		else
			DecisionAI.OnReload()
		end
	Trace("Init","End")
end

--[[ Private ]]
function DecisionAI.Main()
	Trace("DecisionAI Main","Start")
	
	local Owner
	local FriendList
	local EnemyList
	local UnknownList

	if PREV_SCAN_TIME+SCANNING_SPAN+CYCLE_DELAY < TICK_TIME then
		DecisionAI.Scan()
		PREV_SCAN_TIME = TICK_TIME
	end
	
	if PREV_PROCESS_TIME+PROCESS_SPAN+CYCLE_DELAY < TICK_TIME then
		DecisionAI.Proccess()
		PREV_PROCESS_TIME = TICK_TIME
	end
	
	Trace("DecisionAI Main","End")
end

--[[ Private ]]
function DecisionAI.Scan()
	ifCommand(CMD_SEARCH)
	My.Update()
end

--[[ Private ]]
function DecisionAI.Proccess()
	My.PriorityList = TargetPriority.GetPriority(My.Character.Priority)
	
	local Cmd = My.Command
	My.Command = DecisionAI.SelectCommand()
	Trace("AI Command  : " .. Cmd .. "  " .. My.Command)
	
	ifBehavior()
end

--[[ Private ]]
function DecisionAI.OnCallHomun()
	Trace("OnCallHomun", "Start")
		Party.SetParty()
	Trace("OnCallHomun", "End")
end

--[[ Private ]]
function DecisionAI.OnReload()
	Trace("OnReload", "Start") 
		Party.SetParty()
	Trace("OnReload", "End") 
end

--[[ Private ]]
function DecisionAI.SelectCommand()
	local MyData				= Finding.GetActorData(My.ID)
	local MyEnemyList		= MyData.EnemyList
	
	local OwnerData			= Finding.GetActorData(My.Owner.ID)
	local OwnerEnemyList = OwnerData.EnemyList
	
	-- ォ݂Ă̂ŁÂ܂ܖߗDxɂȂ YȂBaseCommand
	local BaseCommand = My.Character.BaseCommand
	local Cmd = BaseCommand
	
	if My.IsMoving() and not Finding.IsEncount() then
		Cmd = My.Command
		
	else
		if (CHASE_START_DISTANCE<=My.OwnerDistance) and (My.PrevOwnerDistance<=My.OwnerDistance) then
			Cmd = CMD_CHASE
			
		elseif My.Command == CMD_GUARD then
			Cmd = CMD_GUARD
			
		elseif My.Command == CMD_SUPPORT then
			Cmd = CMD_SUPPORT
			
		elseif Finding.IsEncount() and MyEnemyList.count==0 and OwnerEnemyList.count==0 and OwnerData.Target==0 then
			Cmd = CMD_STEALTH
			
		elseif Finding.IsEncount() and 0<MyEnemyList.count and (BaseCommand==CMD_ENGAGE or My.ClearedToEngage) then
			Cmd = CMD_ENGAGE
			
		elseif 0<MyEnemyList.count and DENGER_BORDER<=OwnerData.DangerLevel then
			Cmd = CMD_DECOY
			
		end
	end
	
	return Cmd
end
