--[[ Finding ]]
--[[ Position ]]
--[[ Ask ]]
ifMove					= {}
ifHide					= {}
local MoveAction	= {}


-----------------------


--[[ Public ]]
function ifMove.To(posX, posY)
	MoveAction.MoveTo(posX, posY)
end

--[[ Public ]]
function ifMove.ToActor( ActorID )
	MoveAction.MoveToActor(ActorID)
end

--[[ Public ]]
function ifMove.ToOwner()
	MoveAction.MoveToOwner()
end

--[[ Public ]]
function ifMove.NearFriend()
	MoveAction.MoveNearFriend()
end

--[[ Public ]]
function ifMove.NearEnemy()
	MoveAction.MoveNearEnemy()
end

--[[ Public ]]
function ifMove.DangerFriend()
	MoveAction.MoveDangerFriend()
end

--[[ Public ]]
function ifMove.DangerEnemy()
	MoveAction.MoveDangerEnemy()
end

--[[ Public ]]
function ifMove.HoldRange(TargetID, Distance)
	MoveAction.MoveHoldRange(TargetID, Distance)
end


----------------------


--[[ Public ]]
function ifHide.Owner(TargetID)
	MoveAction.MoveHideOwner(TargetID)
end

--[[ Public ]]
function ifHide.NearFriend(TargetID)
	MoveAction.MoveHideNearFriend(TargetID)
end

--[[ Public ]]
function ifHide.Wall()
	MoveAction.MoveHideWall()
end


-----------------------


--[[ Private ]]
function MoveAction.MoveTo(pos1, pos2)
	if not My.IsDelay then
		if IsTable(pos1) then
			Trace(" Move : " .. pos1.X .. " " .. pos1.Y)
			Move(My.ID, pos1.X, pos1.Y)
		else
			Trace(" Move : " .. pos2 .. " " .. pos2)
			Move(My.ID, pos1, pos2)
		end
		
		My.SetDelay( DELAY_MOVE )
		ifChangeState(ST_MOVE)
	end
end

--[[ Private ]]
function MoveAction.MoveToActor(ActorID)
	Trace("Move : Actor")
	MoveAction.MoveTo( GetV(V_POSITION, ActorID) )
end

--[[ Private ]]
function MoveAction.MoveToOwner()
	Trace("Move : Owner")
	MoveAction.MoveToActor( My.Owner.ID )
end

--[[ Private ]]
function MoveAction.MoveNearFriend()
	local ActorIDList = ifFinding.GetActorIDList(ACT_FRIEND)
	local NearFriend = Position.GetNearActorID(ActorIDList, My.ID)
	
	if IsTrue(NearFriend) then
		Trace("Move : NearFriend")
		MoveAction.MoveToActor(NearFriend)
	else
		Trace("Move : NearFriend  NotFound")
	end
end

--[[ Private ]]
function MoveAction.MoveNearEnemy()
	local ActorIDList = ifFinding.GetActorIDList(ACT_ENEMY)
	local NearEnemy = Position.GetNearActorID(ActorIDList, My.ID)
	
	if IsTrue(NearEnemy) then
		Trace("Move : NearEnemy")
		MoveAction.MoveToActor(NearEnemy)
	else
		Trace("Move : NearEnemy  NotFound")
	end
end

--[[ Private ]]
function MoveAction.MoveDangerFriend()
	Trace("Move : DangerFriend")
end

--[[ Private ]]
function MoveAction.MoveDangerEnemy()
	Trace("Move : DangerEnemy")
end

--[[ Private ]]
function MoveAction.MoveHoldRange(TargetID, Distance)
	Trace("Move : HoldRange")
	
	local HoldPosition = Position.GetPosition(TargetID, Distance)
	MoveAction.MoveTo(HoldPosition)
end


--------------------


--[[ Private ]]
function MoveAction.MoveHideOwner(TargetID)
	Trace("Hide : Owner")
	local HidePosition = Position.GetHidePosition(TargetID, 2, My.Owner.ID)
	MoveAction.MoveTo(HidePosition)
end

--[[ Private ]]
function MoveAction.MoveHideNearFriend(TargetID)
	Trace("Hide : NearFriend")
	local FriendIDList	= ifFinding.GetActorIDList(ACT_FRIEND)
	local FriendID			= Position.GetNearActorID(FriendIDList, My.ID)
	local HidePosition	= Position.GetPosition(TargetID, 2, FriendID)
	MoveAction.MoveTo(HidePosition)
end

--[[ Private ]]
function MoveAction.MoveHideWall()
	Trace("Hide : Wall")
end

